#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <netinet/in.h>
#include "jaghdr.h"
#include "jagserv.h"
#include "gemdos.h"

static void MkOutFileName(char *outname, char *inname)
{  char *p;

   strcpy(outname, inname);
   p = strrchr(outname, '.');
   if (p != NULL)
   {
      strcpy(p, ".jag");
   }
   else
   {
      strcat(outname, ".jag");
   }
}

static long GetSize(FILE *stream)
{  long AktPos, Size;

   AktPos = ftell(stream);
   fseek(stream, 0, SEEK_END);
   Size = ftell(stream);
   fseek(stream, AktPos, SEEK_SET);
   return(Size);
}

int main(int argc, char *argv[])
{  FILE *BinFile, *JagFile;
   PH GemdosHdr;
   JS_HDR JagserverHdr;
   unsigned long Dummy, StartAddr;
   char outname[256], *p;

   if ((argc != 2) && (argc != 4))
   {
      puts("Usage:");
      printf("%s [-s <startaddr>] <file>\n", argv[0]);
      puts("adds jag header to file");
   }
   else
   {
      if (argc == 4)
      {
         StartAddr = strtol(argv[2], NULL, 0);
         p = argv[3];
      }
      else
      {
         StartAddr = DEFAULT_BASE;
         p = argv[1];
      }
      MkOutFileName(outname, p);
      BinFile = fopen(p, "r");
      if (BinFile != (FILE *)NULL)
      {
         JagFile = fopen(outname, "w");
         if (JagFile != (FILE *)NULL)
         {
            PhSet(&GemdosHdr, GetSize(BinFile), 0, 0, 0, 0, 0);
            PhWrite(JagFile, &GemdosHdr);
            JsSet(&JagserverHdr, JAGSERVER_TYPE_3, StartAddr, 0);
            JsWrite(JagFile, &JagserverHdr);
            Dummy = htonl(StartAddr);
            fwrite(&Dummy, sizeof(unsigned long), 1, JagFile);
            do {
               Dummy = fread(outname, 1, 256, BinFile);
               if (Dummy > 0)
                  fwrite(outname, 1, Dummy, JagFile);
            } while (Dummy > 0);
            fclose(JagFile);
         }
         else
         {
            printf("can not open <%s>\n", outname);
         }
         fclose(BinFile);
      }
      else
      {
         printf("can not open <%s>\n", argv[1]);
      }
   }
}
