#include <stdio.h>
#include <netinet/in.h>
#include "boolean.h"
#include "gemdos.h"

BOOL PhRead(FILE *stream, PH *GemdosHeader)
{
   return(fread(GemdosHeader, sizeof(PH), 1, stream) == 1);
}

BOOL PhWrite(FILE *stream, PH *GemdosHeader)
{
   return(fwrite(GemdosHeader, sizeof(PH), 1, stream) == 1);
}

BOOL PhIsHdr(PH *GemdosHeader)
{
   return(ntohs(GemdosHeader->ph_branch) == GEMDOS_BRANCH);
}

void PhSet(PH *GemdosHeader, LONG tlen, LONG dlen, LONG blen, LONG slen, LONG prgflags, WORD absflags)
{
   GemdosHeader->ph_branch = htons(GEMDOS_BRANCH);
   GemdosHeader->ph_tlen = htonl(tlen);
   GemdosHeader->ph_dlen = htonl(dlen);
   GemdosHeader->ph_blen = htonl(blen);
   GemdosHeader->ph_slen = htonl(slen);
   GemdosHeader->ph_res1 = htonl(0);
   GemdosHeader->ph_prgflags = htonl(prgflags);
   GemdosHeader->ph_absflag = htons(absflags);
}

void PhGet(PH *GemdosHeader, LONG *tlen, LONG *dlen, LONG *blen, LONG *slen, LONG *prgflags, WORD *absflags)
{
   *tlen = ntohl(GemdosHeader->ph_tlen);
   *dlen = ntohl(GemdosHeader->ph_dlen);
   *blen = ntohl(GemdosHeader->ph_blen);
   *slen = ntohl(GemdosHeader->ph_slen);
   *prgflags = ntohl(GemdosHeader->ph_prgflags);
   *absflags = ntohs(GemdosHeader->ph_absflag);
}

void PhReloc(PH *GemdosHeader, unsigned long *addr)
{  unsigned long textlen, datalen, bss_len, symblen, offset, addr2;
   unsigned char *reloptr, *pdata2;

   addr2 = *addr;
   textlen = ntohl(GemdosHeader->ph_tlen);
   datalen = ntohl(GemdosHeader->ph_dlen);
   bss_len = ntohl(GemdosHeader->ph_blen);
   symblen = ntohl(GemdosHeader->ph_slen);
   reloptr = (unsigned char *)GemdosHeader + textlen + datalen + symblen + sizeof(PH);
   offset = ntohl(*(unsigned long *)reloptr); /* first long to relocate */
   reloptr += 4; /* from now only bytes as offset */
   pdata2 = (unsigned char *)GemdosHeader + sizeof(PH) + offset; /* ptr to it */
   addr2 = ntohl(addr2); /* change byte-order */
   while (offset) /* until offset == 0 */
   {
      /* compute new address */
      *(unsigned long *)pdata2 += addr2;
      /* as long as offset is 1 skip 254 byte */
      do {
         offset = (unsigned long)*reloptr;
         ++reloptr;
         if (!--offset)
            pdata2 += 254;
      } while (!offset);
      pdata2 += ++offset; /* next address */
   }
}
