#ifndef GEMODS_H
#define GEMODS_H

#include <stdio.h>
#include "portab.h"
#include "boolean.h"

#define GEMDOS_BRANCH 0x601A

#pragma pack(2)

typedef struct
{
   WORD ph_branch;  /* 0x601A */
   LONG ph_tlen;    /* Lnge des TEXT-Abschnittes */
   LONG ph_dlen;    /* Lnge des DATA-Abschnittes */
   LONG ph_blen;    /* Lnge des BSS-Abshnittes */
   LONG ph_slen;    /* Lnge der Symboltabelle */
   LONG ph_res1;    /* reserviert; mu 0 sein */
#if 0
   struct {         /* Bitfeld fr PureC, ansonsten nachprfen! */
      unsigned tpasize: 4;    /* Bit 28..31 */
      unsigned res1: 12;      /* Bit 16..27 */
      unsigned res2: 4;       /* Bit 12..15 */
      unsigned shared: 1;     /* Bit 11 */
      unsigned res3: 3;       /* Bit 8..10 */
      unsigned protection: 4; /* Bit 4..7 */
      unsigned res4: 1;       /* Bit 3 */
      unsigned malt: 1;       /* Bit 2 */
      unsigned lalt: 1;       /* Bit 1 */
      unsigned fload: 1;      /* Bit 0 */
   } ph_prgflags;
#else
   LONG ph_prgflags;
#endif
   WORD ph_absflag; /* 0: Relozierungsinformationen vorhanden */
} PH;

BOOL PhRead(FILE *stream, PH *GemdosHeader);
BOOL PhWrite(FILE *stream, PH *GemdosHeader);
BOOL PhIsHdr(PH *GemdosHeader);
void PhSet(PH *GemdosHeader, LONG tlen, LONG dlen, LONG blen, LONG slen, LONG prgflags, WORD absflags);
void PhGet(PH *GemdosHeader, LONG *tlen, LONG *dlen, LONG *blen, LONG *slen, LONG *prgflags, WORD *absflags);
void PhReloc(PH *GemdosHeader, unsigned long *addr);

#endif
