#include <stdio.h>
#include "jaghdr.h"
#include "jagserv.h"
#include "gemdos.h"
#include "coff.h"

int main(int argc, char *argv[])
{  FILE *JagFile;
   PH GemdosHdr;
   JS_HDR JagserverHdr;
   unsigned long Dummy;
   LONG tlen, dlen, blen, slen, prgflags, start_addr, new_len;
   WORD absflags, jagtype;

   if (argc != 2)
   {
      puts("Usage:");
      printf("%s <file>\n", argv[0]);
      puts("prints information about jaguar fileheader");
   }
   else
   {
      JagFile = fopen(argv[1], "r");
      if (JagFile != (FILE *)NULL)
      {
         if (PhRead(JagFile, &GemdosHdr))
         {
            if (PhIsHdr(&GemdosHdr))
            {
               puts("found GEMDOS header");
               PhGet(&GemdosHdr, &tlen, &dlen, &blen, &slen, &prgflags, &absflags);
               printf("textlen   0x%lX\n", tlen);
               printf("datalen   0x%lX\n", dlen);
               printf("bss_len   0x%lX\n", blen);
               printf("symblen   0x%lX\n", slen);
               printf("prgflags  0x%lX\n", prgflags);
               printf("relinfos  0x%X\n",  absflags);
               if (JsRead(JagFile, &JagserverHdr))
               {
                  if (JsIsHdr(&JagserverHdr))
                  {
                     puts("found JAGSERVER header");
                     JsGet(&JagserverHdr, &jagtype, &start_addr, &new_len);
                     printf("jagtype   0x%X\n",  jagtype);
                     printf("startaddr 0x%lX\n", start_addr);
                     printf("new_len   0x%lX\n", new_len);
                     if (jagtype != JAGSERVER_TYPE_2)
                     {
                        if (fread(&Dummy, sizeof(unsigned long), 1, JagFile) == 1)
                        {
                           printf("dummy     0x%lX\n", ntohl(Dummy));
                        }
                     }
                  }
                  else
                  {
                     puts("found BJL program");
               }
               }
            }
            else if (ntohs(GemdosHdr.ph_branch) == COFF_HDR)
            {
               puts("found COFF header");
            }
            else
            {
               puts("found no header");
            }
         }
         fclose(JagFile);
      }
      else
      {
         printf("can not open <%s>\n", argv[1]);
      }
   }
}
