#include <stdio.h>
#include <netinet/in.h>
#include "jagserv.h"

BOOL JsRead(FILE *stream, JS_HDR *JagserverHeader)
{
   return(fread(JagserverHeader, sizeof(JS_HDR), 1, stream) == 1);
}

BOOL JsWrite(FILE *stream, JS_HDR *JagserverHeader)
{
   return(fwrite(JagserverHeader, sizeof(JS_HDR), 1, stream) == 1);
}

BOOL JsIsHdr(JS_HDR *JagserverHeader)
{
   return(ntohl(JagserverHeader->js_tag) == JAGSERVER_HEADER_TAG);
}

void JsSet(JS_HDR *JagserverHeader, WORD jagtype, LONG start_addr, LONG new_len)
{
   JagserverHeader->js_tag = htonl(JAGSERVER_HEADER_TAG);
   JagserverHeader->js_type = htons(jagtype);
   JagserverHeader->js_start_addr = htonl(start_addr);
   JagserverHeader->js_new_len = htonl(new_len);
}

void JsGet(JS_HDR *JagserverHeader, WORD *jagtype, LONG *start_addr, LONG *new_len)
{
   *jagtype = ntohs(JagserverHeader->js_type);
   *start_addr = ntohl(JagserverHeader->js_start_addr);
   *new_len = ntohl(JagserverHeader->js_new_len);
}
