#ifndef JAGSERV_H
#define JAGSERV_H

#include <stdio.h>
#include "portab.h"
#include "boolean.h"

#define JAGSERVER_HEADER_TAG 0x4A414752 /* JAGR */
#define JAGSERVER_TYPE_2     2
#define JAGSERVER_TYPE_3     3

#pragma pack(2)

typedef struct {
   LONG js_tag;
   WORD js_type;
   LONG js_start_addr;
   LONG js_new_len;
} JS_HDR;

BOOL JsRead(FILE *stream, JS_HDR *JagserverHeader);
BOOL JsWrite(FILE *stream, JS_HDR *GemdosHeader);
BOOL JsIsHdr(JS_HDR *JagserverHeader);
void JsSet(JS_HDR *JagserverHeader, WORD jagtype, LONG start_addr, LONG new_len);
void JsGet(JS_HDR *JagserverHeader, WORD *jagtype, LONG *start_addr, LONG *new_len);

#endif
